#! /usr/bin/python

import time
import xusb
import psptalk

def show_voltage(d):
	mask = d.ps_mask()

	print ("%-20s:" % ("Voltage")),
	d.refresh_volts()
	for i in range(0,4):
		voltage = d.voltage(i)
		if voltage >= 0:
			v = voltage / 10.0
			if (1 << i) & mask:
				print "   %4.1f     |" % (v),
			else:
				print "            |",
	print


def show_hubs(d):
	mask = d.hub_mask()
	hub_stat = d.hub_stat()
	print ("%-20s:" % ("USB HUBS:")),
	for i in range(0,8):
		if (1 << i) & mask:
			t = (hub_stat >> i) & 0x1
			if t:
				print "  +  |",
			else:
				print "  -  |",
		else:
			print "     |",
	print

def tws_jump(dev):
	port = dev.tws_port_get()
	newport = (port + 1) % 2
	print "JUMPING FROM ", port, " TO ", newport
	dev.tws_port_set(newport)


spec = xusb.Spec("Power Supplies", 0xe4e4, 0x1183, 2, 1, 2, 0x04, 0x88)
devs = spec.find_all()

pspdevs = []
for d in devs:
	d.claim()
	d.showinfo()
	ps = psptalk.PSDev(d)
	pspdevs.append(ps)

dev = pspdevs[0]

print "Device and Protocol are ready (ps_mask=0x%X hub_mask=0x%X tws_power=0x%X, tws_port=%d)" % (dev.ps_mask(), dev.hub_mask(), dev.tws_pwr_get(), dev.tws_port_get())
print "Watchdog mode = ", dev.tws_mode_get()
dev.tws_mode_set(0);
print "Watchdog mode = ", dev.tws_mode_get()

for i in range(1, 100):
        dev.leds(i)
        time.sleep(1)
        show_hubs(dev)
        show_voltage(dev)
	if i == 5:
		tws_jump(dev)
